module BestFirst where

import Tree
import PQueue

-- using PQueue with empty, insert, top, pop, isempty

bestFirst :: (a -> Bool) -> (Tree a -> Int) -> Tree a -> Maybe a
bestFirst p f t = bfs p (insert t (empty f))

bfs :: (a -> Bool) -> PQ (Tree a) -> Maybe a
bfs p pq | isempty pq = Nothing
         | otherwise = if p x then Just x
                       else bfs p (insertnode t1 (insertnode t2 pq'))
               where Node t1 x t2 = top pq
                     pq'          = pop pq

insertnode :: Tree a -> PQ (Tree a) -> PQ (Tree a)
insertnode Nil pq = pq
insertnode t pq   = insert t pq

eval :: Tree Int -> Int
eval Nil = 0
eval (Node t1 x t2) = x

-- λ> breadthFirst (>19) inf
-- Just 20
-- (9.72 secs, 1,031,895,824 bytes)
-- required examining 2097151 nodes

-- λ> bestFirst (>19) eval inf
-- Just 20
-- (0.02 secs, 156,592 bytes)
-- required examining 21 nodes

-- λ> breadthFirst (>100) inf
-- 
-- Interrupted.

-- λ> bestFirst (>100) eval inf
-- Just 101
-- (0.01 secs, 433,256 bytes)
-- required examining 101 nodes
