module BreadthFirst where

import Tree

bf_traverse :: Tree a -> [a]
bf_traverse t = bft [t]
    where
        bft [] = []
        bft xs = [x | Node _ x _ <- xs] ++ bft (concat [ [t1,t2] | Node t1 _ t2 <- xs ])

breadthFirst :: (a -> Bool) -> Tree a -> Maybe a
breadthFirst p t = head( [Just x | x <- bf_traverse t, p x] ++ [Nothing] )

-- λ> breadthFirst (>0) inf
-- Just 1
-- (0.01 secs, 93,200 bytes)
