module PQueue
  (PQ,empty,insert,top,pop,isempty) where

data PQ a = MkPQ (a->Int) [a]

invariant :: PQ a -> Bool
invariant (MkPQ f xs)  =
  and [ f x >= f y | (x,y) <- zip xs (tail xs) ]

empty :: (a->Int) -> PQ a
empty f =  MkPQ f []

insert :: a -> PQ a -> PQ a
insert x (MkPQ f ys)  =  MkPQ f (ins x ys)
  where
  ins x []                   =  [x]
  ins x (y:ys) | f x >= f y  =  x : y : ys
               | f x < f y   =  y : ins x ys

top :: PQ a -> a     -- return item with highest priority
top (MkPQ _ (x:xs)) = x

pop :: PQ a -> PQ a  -- remove item with highest priority
pop (MkPQ f (x:xs)) = MkPQ f xs

isempty :: PQ a -> Bool
isempty (MkPQ f xs) = null xs
